<a id="mypy-boto3-storagegateway"></a>

# mypy-boto3-storagegateway

[![PyPI - mypy-boto3-storagegateway](https://img.shields.io/pypi/v/mypy-boto3-storagegateway.svg?color=blue)](https://pypi.org/project/mypy-boto3-storagegateway)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-storagegateway.svg?color=blue)](https://pypi.org/project/mypy-boto3-storagegateway)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-storagegateway?color=blue)](https://pypistats.org/packages/mypy-boto3-storagegateway)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.StorageGateway 1.17.102](https://boto3.amazonaws.com/v1/documentation/api/1.17.102/reference/services/storagegateway.html#StorageGateway)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-buider 4.20.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-storagegateway docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_storagegateway/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-storagegateway](#mypy-boto3-storagegateway)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

Install `boto3-stubs` for `StorageGateway` service.

```bash
python -m pip install boto3-stubs[storagegateway]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[storagegateway]` in your environment:
  `python -m pip install 'boto3-stubs[storagegateway]'`

Both type checking and auto-complete should work for `StorageGateway` service.
No explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `boto-stubs[storagegateway]` in your environment:
  `python -m pip install 'boto3-stubs[storagegateway]'`

Both type checking and auto-complete should work for `StorageGateway` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`boto3-stubs` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[storagegateway]` in your environment:
  `python -m pip install 'boto3-stubs[storagegateway]'`
- Run `mypy` as usual

Type checking should work for `StorageGateway` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[storagegateway]` in your environment:
  `python -m pip install 'boto3-stubs[storagegateway]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `StorageGateway` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`StorageGatewayClient` provides annotations for
`boto3.client("storagegateway")`.

```python
import boto3

from mypy_boto3_storagegateway import StorageGatewayClient

client: StorageGatewayClient = boto3.client("storagegateway")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: StorageGatewayClient = session.client("storagegateway")
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_storagegateway.paginator` module contains type annotations for all
paginators.

```python
from mypy_boto3_storagegateway import StorageGatewayClient
from mypy_boto3_storagegateway.paginator import (
    DescribeTapeArchivesPaginator,
    DescribeTapeRecoveryPointsPaginator,
    DescribeTapesPaginator,
    DescribeVTLDevicesPaginator,
    ListFileSharesPaginator,
    ListFileSystemAssociationsPaginator,
    ListGatewaysPaginator,
    ListTagsForResourcePaginator,
    ListTapePoolsPaginator,
    ListTapesPaginator,
    ListVolumesPaginator,
)

client: StorageGatewayClient = boto3.client("storagegateway")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
describe_tape_archives_paginator: DescribeTapeArchivesPaginator = client.get_paginator("describe_tape_archives")
describe_tape_recovery_points_paginator: DescribeTapeRecoveryPointsPaginator = client.get_paginator("describe_tape_recovery_points")
describe_tapes_paginator: DescribeTapesPaginator = client.get_paginator("describe_tapes")
describe_vtl_devices_paginator: DescribeVTLDevicesPaginator = client.get_paginator("describe_vtl_devices")
list_file_shares_paginator: ListFileSharesPaginator = client.get_paginator("list_file_shares")
list_file_system_associations_paginator: ListFileSystemAssociationsPaginator = client.get_paginator("list_file_system_associations")
list_gateways_paginator: ListGatewaysPaginator = client.get_paginator("list_gateways")
list_tags_for_resource_paginator: ListTagsForResourcePaginator = client.get_paginator("list_tags_for_resource")
list_tape_pools_paginator: ListTapePoolsPaginator = client.get_paginator("list_tape_pools")
list_tapes_paginator: ListTapesPaginator = client.get_paginator("list_tapes")
list_volumes_paginator: ListVolumesPaginator = client.get_paginator("list_volumes")
```

<a id="literals"></a>

### Literals

`mypy_boto3_storagegateway.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from mypy_boto3_storagegateway.literals import (
    ActiveDirectoryStatusType,
    AvailabilityMonitorTestStatusType,
    CaseSensitivityType,
    DescribeTapeArchivesPaginatorName,
    DescribeTapeRecoveryPointsPaginatorName,
    DescribeTapesPaginatorName,
    DescribeVTLDevicesPaginatorName,
    FileShareTypeType,
    HostEnvironmentType,
    ListFileSharesPaginatorName,
    ListFileSystemAssociationsPaginatorName,
    ListGatewaysPaginatorName,
    ListTagsForResourcePaginatorName,
    ListTapePoolsPaginatorName,
    ListTapesPaginatorName,
    ListVolumesPaginatorName,
    ObjectACLType,
    PoolStatusType,
    RetentionLockTypeType,
    SMBSecurityStrategyType,
    TapeStorageClassType,
)

def check_value(value: ActiveDirectoryStatusType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_storagegateway.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_storagegateway.type_defs import (
    ActivateGatewayInputTypeDef,
    ActivateGatewayOutputResponseTypeDef,
    AddCacheInputTypeDef,
    AddCacheOutputResponseTypeDef,
    AddTagsToResourceInputTypeDef,
    AddTagsToResourceOutputResponseTypeDef,
    AddUploadBufferInputTypeDef,
    AddUploadBufferOutputResponseTypeDef,
    AddWorkingStorageInputTypeDef,
    AddWorkingStorageOutputResponseTypeDef,
    AssignTapePoolInputTypeDef,
    AssignTapePoolOutputResponseTypeDef,
    AssociateFileSystemInputTypeDef,
    AssociateFileSystemOutputResponseTypeDef,
    AttachVolumeInputTypeDef,
    AttachVolumeOutputResponseTypeDef,
    AutomaticTapeCreationPolicyInfoTypeDef,
    AutomaticTapeCreationRuleTypeDef,
    BandwidthRateLimitIntervalTypeDef,
    CacheAttributesTypeDef,
    CachediSCSIVolumeTypeDef,
    CancelArchivalInputTypeDef,
    CancelArchivalOutputResponseTypeDef,
    CancelRetrievalInputTypeDef,
    CancelRetrievalOutputResponseTypeDef,
    ChapInfoTypeDef,
    CreateCachediSCSIVolumeInputTypeDef,
    CreateCachediSCSIVolumeOutputResponseTypeDef,
    CreateNFSFileShareInputTypeDef,
    CreateNFSFileShareOutputResponseTypeDef,
    CreateSMBFileShareInputTypeDef,
    CreateSMBFileShareOutputResponseTypeDef,
    CreateSnapshotFromVolumeRecoveryPointInputTypeDef,
    CreateSnapshotFromVolumeRecoveryPointOutputResponseTypeDef,
    CreateSnapshotInputTypeDef,
    CreateSnapshotOutputResponseTypeDef,
    CreateStorediSCSIVolumeInputTypeDef,
    CreateStorediSCSIVolumeOutputResponseTypeDef,
    CreateTapePoolInputTypeDef,
    CreateTapePoolOutputResponseTypeDef,
    CreateTapeWithBarcodeInputTypeDef,
    CreateTapeWithBarcodeOutputResponseTypeDef,
    CreateTapesInputTypeDef,
    CreateTapesOutputResponseTypeDef,
    DeleteAutomaticTapeCreationPolicyInputTypeDef,
    DeleteAutomaticTapeCreationPolicyOutputResponseTypeDef,
    DeleteBandwidthRateLimitInputTypeDef,
    DeleteBandwidthRateLimitOutputResponseTypeDef,
    DeleteChapCredentialsInputTypeDef,
    DeleteChapCredentialsOutputResponseTypeDef,
    DeleteFileShareInputTypeDef,
    DeleteFileShareOutputResponseTypeDef,
    DeleteGatewayInputTypeDef,
    DeleteGatewayOutputResponseTypeDef,
    DeleteSnapshotScheduleInputTypeDef,
    DeleteSnapshotScheduleOutputResponseTypeDef,
    DeleteTapeArchiveInputTypeDef,
    DeleteTapeArchiveOutputResponseTypeDef,
    DeleteTapeInputTypeDef,
    DeleteTapeOutputResponseTypeDef,
    DeleteTapePoolInputTypeDef,
    DeleteTapePoolOutputResponseTypeDef,
    DeleteVolumeInputTypeDef,
    DeleteVolumeOutputResponseTypeDef,
    DescribeAvailabilityMonitorTestInputTypeDef,
    DescribeAvailabilityMonitorTestOutputResponseTypeDef,
    DescribeBandwidthRateLimitInputTypeDef,
    DescribeBandwidthRateLimitOutputResponseTypeDef,
    DescribeBandwidthRateLimitScheduleInputTypeDef,
    DescribeBandwidthRateLimitScheduleOutputResponseTypeDef,
    DescribeCacheInputTypeDef,
    DescribeCacheOutputResponseTypeDef,
    DescribeCachediSCSIVolumesInputTypeDef,
    DescribeCachediSCSIVolumesOutputResponseTypeDef,
    DescribeChapCredentialsInputTypeDef,
    DescribeChapCredentialsOutputResponseTypeDef,
    DescribeFileSystemAssociationsInputTypeDef,
    DescribeFileSystemAssociationsOutputResponseTypeDef,
    DescribeGatewayInformationInputTypeDef,
    DescribeGatewayInformationOutputResponseTypeDef,
    DescribeMaintenanceStartTimeInputTypeDef,
    DescribeMaintenanceStartTimeOutputResponseTypeDef,
    DescribeNFSFileSharesInputTypeDef,
    DescribeNFSFileSharesOutputResponseTypeDef,
    DescribeSMBFileSharesInputTypeDef,
    DescribeSMBFileSharesOutputResponseTypeDef,
    DescribeSMBSettingsInputTypeDef,
    DescribeSMBSettingsOutputResponseTypeDef,
    DescribeSnapshotScheduleInputTypeDef,
    DescribeSnapshotScheduleOutputResponseTypeDef,
    DescribeStorediSCSIVolumesInputTypeDef,
    DescribeStorediSCSIVolumesOutputResponseTypeDef,
    DescribeTapeArchivesInputTypeDef,
    DescribeTapeArchivesOutputResponseTypeDef,
    DescribeTapeRecoveryPointsInputTypeDef,
    DescribeTapeRecoveryPointsOutputResponseTypeDef,
    DescribeTapesInputTypeDef,
    DescribeTapesOutputResponseTypeDef,
    DescribeUploadBufferInputTypeDef,
    DescribeUploadBufferOutputResponseTypeDef,
    DescribeVTLDevicesInputTypeDef,
    DescribeVTLDevicesOutputResponseTypeDef,
    DescribeWorkingStorageInputTypeDef,
    DescribeWorkingStorageOutputResponseTypeDef,
    DetachVolumeInputTypeDef,
    DetachVolumeOutputResponseTypeDef,
    DeviceiSCSIAttributesTypeDef,
    DisableGatewayInputTypeDef,
    DisableGatewayOutputResponseTypeDef,
    DisassociateFileSystemInputTypeDef,
    DisassociateFileSystemOutputResponseTypeDef,
    DiskTypeDef,
    FileShareInfoTypeDef,
    FileSystemAssociationInfoTypeDef,
    FileSystemAssociationSummaryTypeDef,
    GatewayInfoTypeDef,
    JoinDomainInputTypeDef,
    JoinDomainOutputResponseTypeDef,
    ListAutomaticTapeCreationPoliciesInputTypeDef,
    ListAutomaticTapeCreationPoliciesOutputResponseTypeDef,
    ListFileSharesInputTypeDef,
    ListFileSharesOutputResponseTypeDef,
    ListFileSystemAssociationsInputTypeDef,
    ListFileSystemAssociationsOutputResponseTypeDef,
    ListGatewaysInputTypeDef,
    ListGatewaysOutputResponseTypeDef,
    ListLocalDisksInputTypeDef,
    ListLocalDisksOutputResponseTypeDef,
    ListTagsForResourceInputTypeDef,
    ListTagsForResourceOutputResponseTypeDef,
    ListTapePoolsInputTypeDef,
    ListTapePoolsOutputResponseTypeDef,
    ListTapesInputTypeDef,
    ListTapesOutputResponseTypeDef,
    ListVolumeInitiatorsInputTypeDef,
    ListVolumeInitiatorsOutputResponseTypeDef,
    ListVolumeRecoveryPointsInputTypeDef,
    ListVolumeRecoveryPointsOutputResponseTypeDef,
    ListVolumesInputTypeDef,
    ListVolumesOutputResponseTypeDef,
    NFSFileShareDefaultsTypeDef,
    NFSFileShareInfoTypeDef,
    NetworkInterfaceTypeDef,
    NotifyWhenUploadedInputTypeDef,
    NotifyWhenUploadedOutputResponseTypeDef,
    PaginatorConfigTypeDef,
    PoolInfoTypeDef,
    RefreshCacheInputTypeDef,
    RefreshCacheOutputResponseTypeDef,
    RemoveTagsFromResourceInputTypeDef,
    RemoveTagsFromResourceOutputResponseTypeDef,
    ResetCacheInputTypeDef,
    ResetCacheOutputResponseTypeDef,
    ResponseMetadataTypeDef,
    RetrieveTapeArchiveInputTypeDef,
    RetrieveTapeArchiveOutputResponseTypeDef,
    RetrieveTapeRecoveryPointInputTypeDef,
    RetrieveTapeRecoveryPointOutputResponseTypeDef,
    SMBFileShareInfoTypeDef,
    SetLocalConsolePasswordInputTypeDef,
    SetLocalConsolePasswordOutputResponseTypeDef,
    SetSMBGuestPasswordInputTypeDef,
    SetSMBGuestPasswordOutputResponseTypeDef,
    ShutdownGatewayInputTypeDef,
    ShutdownGatewayOutputResponseTypeDef,
    StartAvailabilityMonitorTestInputTypeDef,
    StartAvailabilityMonitorTestOutputResponseTypeDef,
    StartGatewayInputTypeDef,
    StartGatewayOutputResponseTypeDef,
    StorediSCSIVolumeTypeDef,
    TagTypeDef,
    TapeArchiveTypeDef,
    TapeInfoTypeDef,
    TapeRecoveryPointInfoTypeDef,
    TapeTypeDef,
    UpdateAutomaticTapeCreationPolicyInputTypeDef,
    UpdateAutomaticTapeCreationPolicyOutputResponseTypeDef,
    UpdateBandwidthRateLimitInputTypeDef,
    UpdateBandwidthRateLimitOutputResponseTypeDef,
    UpdateBandwidthRateLimitScheduleInputTypeDef,
    UpdateBandwidthRateLimitScheduleOutputResponseTypeDef,
    UpdateChapCredentialsInputTypeDef,
    UpdateChapCredentialsOutputResponseTypeDef,
    UpdateFileSystemAssociationInputTypeDef,
    UpdateFileSystemAssociationOutputResponseTypeDef,
    UpdateGatewayInformationInputTypeDef,
    UpdateGatewayInformationOutputResponseTypeDef,
    UpdateGatewaySoftwareNowInputTypeDef,
    UpdateGatewaySoftwareNowOutputResponseTypeDef,
    UpdateMaintenanceStartTimeInputTypeDef,
    UpdateMaintenanceStartTimeOutputResponseTypeDef,
    UpdateNFSFileShareInputTypeDef,
    UpdateNFSFileShareOutputResponseTypeDef,
    UpdateSMBFileShareInputTypeDef,
    UpdateSMBFileShareOutputResponseTypeDef,
    UpdateSMBFileShareVisibilityInputTypeDef,
    UpdateSMBFileShareVisibilityOutputResponseTypeDef,
    UpdateSMBSecurityStrategyInputTypeDef,
    UpdateSMBSecurityStrategyOutputResponseTypeDef,
    UpdateSnapshotScheduleInputTypeDef,
    UpdateSnapshotScheduleOutputResponseTypeDef,
    UpdateVTLDeviceTypeInputTypeDef,
    UpdateVTLDeviceTypeOutputResponseTypeDef,
    VTLDeviceTypeDef,
    VolumeInfoTypeDef,
    VolumeRecoveryPointInfoTypeDef,
    VolumeiSCSIAttributesTypeDef,
)

def get_structure() -> ActivateGatewayInputTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`mypy-boto3-storagegateway` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[mypy-boto3-storagegateway docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_storagegateway/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
